### Xilinx Processor IP Library

<hl>Software Drivers</hl>

Main Page | Data Structures | File List | Data Fields | Globals

# xuartlite.c File Reference

## Detailed Description

Contains required functions for the XUartLite driver. See the xuartlite.h header file for more details on this driver.

     MODIFICATION HISTORY:

     Ver   Who  Date     Changes
     ----- ---- -------- -----------------------------------------------
     1.00a ecm  08/31/01 First release
     1.00b jhl  02/21/02 Repartitioned the driver for smaller files
     1.00b rmm  05/13/03 Fixed diab compiler warnings relating to asserts
     1.01a jvb  12/13/05 I changed Initialize() into CfgInitialize(), and made
                         CfgInitialize() take a pointer to a config structure
                         instead of a device id. I moved Initialize() into
                         xgpio_sinit.c, and had Initialize() call CfgInitialize()
                         after it retrieved the config structure using the device
                         id. I removed include of xparameters.h along with any
                         dependencies on xparameters.h and the _g.c config table.
     1.01a wsy  05/08/06 fix CR220811 and CR224103.
     1.12a mta  03/31/07 Updated to new coding conventions
     1.13a sv   01/21/08 Updated driver to support access through DCR bus
     1.14a sdm  09/26/08 Updated code to avoid race condition in
    		      XUartLite_SendBuffer

## Functions

int | XUartLite_CfgInitialize (XUartLite *InstancePtr, XUartLite_Config *Config, u32 EffectiveAddr)
unsigned int | XUartLite_Send (XUartLite *InstancePtr, u8 *DataBufferPtr, unsigned int NumBytes)
unsigned int | XUartLite_Recv (XUartLite *InstancePtr, u8 *DataBufferPtr, unsigned int NumBytes)
void | XUartLite_ResetFifos (XUartLite *InstancePtr)
int | XUartLite_IsSending (XUartLite *InstancePtr)
unsigned int | XUartLite_SendBuffer (XUartLite *InstancePtr)
unsigned int | XUartLite_ReceiveBuffer (XUartLite *InstancePtr)

## Function Documentation

int XUartLite_CfgInitialize | ( | XUartLite * | InstancePtr,
|  | XUartLite_Config * | Config,
|  | u32 | EffectiveAddr
| ) |

Initialize a XUartLite instance. The receive and transmit FIFOs of the UART are not flushed, so the user may want to flush them. The hardware device does not have any way to disable the receiver such that any valid data may be present in the receive FIFO. This function disables the UART interrupt. The baudrate and format of the data are fixed in the hardware at hardware build time.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.
  | Config | is a reference to a structure containing information about a specific UART Lite device. This function initializes an InstancePtr object for a specific device specified by the contents of Config. This function can initialize multiple instance objects with the use of multiple calls giving different Config information on each call.

  EffectiveAddr

  is the device base address in the virtual memory address space. The caller is responsible for keeping the address mapping from EffectiveAddr to the device physical base address unchanged once this function is invoked. Unexpected errors may occur if the address mapping changes after this function is called. If address translation is not used, use Config->BaseAddress for this parameters, passing the physical address instead.

Returns:
  - XST_SUCCESS if everything starts up as expected.

Note:
  The Config pointer argument is not used by this function, but is provided to keep the function signature consistent with other drivers.

int XUartLite_IsSending | ( | XUartLite * | InstancePtr | ) |

This function determines if the specified UART is sending data. If the transmitter register is not empty, it is sending data.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.

Returns:
  A value of TRUE if the UART is sending data, otherwise FALSE.

Note:
  None.

unsigned int XUartLite_ReceiveBuffer | ( | XUartLite * | InstancePtr | ) |

This function receives a buffer that has been previously specified by setting up the instance variables of the instance. This function is designed to be an internal function for the XUartLite component such that it may be called from a shell function that sets up the buffer or from an interrupt handler.

This function will attempt to receive a specified number of bytes of data from the UART and store it into the specified buffer. This function is designed for either polled or interrupt driven modes. It is non-blocking such that it will return if there is no data has already received by the UART.

In a polled mode, this function will only receive as much data as the UART can buffer, either in the receiver or in the FIFO if present and enabled. The application may need to call it repeatedly to receive a buffer. Polled mode is the default mode of operation for the driver.

In interrupt mode, this function will start receiving and then the interrupt handler of the driver will continue until the buffer has been received. A callback function, as specified by the application, will be called to indicate the completion of receiving the buffer or when any receive errors or timeouts occur. Interrupt mode must be enabled using the SetOptions function.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.

Returns:
  The number of bytes received.

Note:
  None.

unsigned int XUartLite_Recv | ( | XUartLite * | InstancePtr,
|  | u8 * | DataBufferPtr,
|  | unsigned int | NumBytes
| ) |

This function will attempt to receive a specified number of bytes of data from the UART and store it into the specified buffer. This function is designed for either polled or interrupt driven modes. It is non-blocking such that it will return if no data has already received by the UART.

In a polled mode, this function will only receive as much data as the UART can buffer in the FIFO. The application may need to call it repeatedly to receive a buffer. Polled mode is the default mode of operation for the driver.

In interrupt mode, this function will start receiving and then the interrupt handler of the driver will continue receiving data until the buffer has been received. A callback function, as specified by the application, will be called to indicate the completion of receiving the buffer or when any receive errors or timeouts occur. Interrupt mode must be enabled using the SetOptions function.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.
  | BufferPtr | is pointer to buffer for data to be received into
  | NumBytes | is the number of bytes to be received. A value of zero will stop a previous receive operation that is in progress in interrupt mode.

Returns:
  The number of bytes received.

Note:
  The number of bytes is not asserted so that this function may be called with a value of zero to stop an operation that is already in progress.

void XUartLite_ResetFifos | ( | XUartLite * | InstancePtr | ) |

This function resets the FIFOs, both transmit and receive, of the UART such that they are emptied. Since the UART does not have any way to disable it from receiving data, it may be necessary for the application to reset the FIFOs to get rid of any unwanted data.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance .

Returns:
  None.

Note:
  None.

unsigned int XUartLite_Send | ( | XUartLite * | InstancePtr,
|  | u8 * | DataBufferPtr,
|  | unsigned int | NumBytes
| ) |

This functions sends the specified buffer of data using the UART in either polled or interrupt driven modes. This function is non-blocking such that it will return before the data has been sent by the UART. If the UART is busy sending data, it will return and indicate zero bytes were sent.

In a polled mode, this function will only send as much data as the UART can buffer in the FIFO. The application may need to call it repeatedly to send a buffer.

In interrupt mode, this function will start sending the specified buffer and then the interrupt handler of the driver will continue sending data until the buffer has been sent. A callback function, as specified by the application, will be called to indicate the completion of sending the buffer.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.
  | BufferPtr | is pointer to a buffer of data to be sent.
  | NumBytes | contains the number of bytes to be sent. A value of zero will stop a previous send operation that is in progress in interrupt mode. Any data that was already put into the transmit FIFO will be sent.

Returns:
  The number of bytes actually sent.

Note:
  The number of bytes is not asserted so that this function may be called with a value of zero to stop an operation that is already in progress.

unsigned int XUartLite_SendBuffer | ( | XUartLite * | InstancePtr | ) |

This function sends a buffer that has been previously specified by setting up the instance variables of the instance. This function is designed to be an internal function for the XUartLite component such that it may be called from a shell function that sets up the buffer or from an interrupt handler.

This function sends the specified buffer of data to the UART in either polled or interrupt driven modes. This function is non-blocking such that it will return before the data has been sent by the UART.

In a polled mode, this function will only send as much data as the UART can buffer, either in the transmitter or in the FIFO if present and enabled. The application may need to call it repeatedly to send a buffer.

In interrupt mode, this function will start sending the specified buffer and then the interrupt handler of the driver will continue until the buffer has been sent. A callback function, as specified by the application, will be called to indicate the completion of sending the buffer.

Parameters:

  | InstancePtr | is a pointer to the XUartLite instance.

Returns:
  NumBytes is the number of bytes actually sent (put into the UART transmitter and/or FIFO).

Note:
  None.

Copyright © 1995-2009 Xilinx, Inc. All rights reserved.